/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/
/*---------------------[ Header files ]------------------------*/
/*-------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <iostream.h>
#include <ctype.h>
#include <string.h>
#include "easyjpeg.h"


/*--------------------------------------------------------------*/
/*--------------------------------------------------------------*/




typedef struct trackPoint{
		int x;
		int y;
}trackPoint;

trackPoint matchPoint;


int blockTotal(JPEG_INFO_STRUCT *jpeg_data,int x,int y,int sx,int sy)
	{


	PIXEL_STRUCT *pixel;
	int nx=0,ny=0,length=0,grey_value=0,averageGrey=0,totalGrey=0;

	// set the start_point of the inner box
	int BoxStartX=(x-(sx/2)) , BoxStartY=(y-(sy/2));

	//print box position...
	pixel = jpeg_data->image;
	// copy from inner box points to (0,0) onwards
	for (ny = (BoxStartY) ; ny <= (BoxStartY+(sy))  ; ny++) {
		for (nx = (BoxStartX) ; nx <= (BoxStartX+(sx))  ; nx++) {

		grey_value =  (((int)pixel[(nx)+(ny*(jpeg_data->width))].r) +
					  ((int)pixel[(nx)+(ny*(jpeg_data->width))].g) + 
					  ((int)pixel[(nx)+(ny*(jpeg_data->width))].b));

	//	cout << (grey_value/3) << "\n";


		totalGrey += (grey_value);
		}

	}

	return(totalGrey);

}

void Image_CopySection(JPEG_INFO_STRUCT *jpeg_data,int x, int y)
{
	PIXEL_STRUCT *pixel;
	int nx,ny,length;

	// set the size of the inner box
	int innerBoxSizeX = 30;
	int innerBoxSizeY = 30;
	
	int BoxStartX;
	int BoxStartY;
	
	BoxStartX=(x-(innerBoxSizeX/2));
	BoxStartY=(y-(innerBoxSizeY/2));


	length = jpeg_data->width * jpeg_data->height;
	pixel = jpeg_data->image;


	// copy from inner box points to (0,0) onwards
	for (ny = 0 ; ny < (innerBoxSizeY)  ; ny++) {
		for (nx = 0 ; nx < (innerBoxSizeX)  ; nx++) {

		pixel[(nx)+(ny*(jpeg_data->width))] =
					pixel[(BoxStartX+nx)+((ny+BoxStartY)*(jpeg_data->width))];




		}
	}
}










void Image_ColorBlock(JPEG_INFO_STRUCT *jpeg_data,int x, int y)
{
	PIXEL_STRUCT *pixel;
	int nx,ny;

	// set the size of the inner box
	int innerBoxSizeX = 8;
	int innerBoxSizeY = 8;
	
	int BoxStartX;
	int BoxStartY;
	
	BoxStartX=(x-(innerBoxSizeX/2));
	BoxStartY=(y-(innerBoxSizeY/2));

	cout << "\n[" << x << "," << y << "]";

	pixel = jpeg_data->image;



	for (ny = 0 ; ny < (innerBoxSizeY)  ; ny++) {
		for (nx = 0 ; nx < (innerBoxSizeX)  ; nx++) {

		pixel[(BoxStartX+nx)+((BoxStartY+ny)*(jpeg_data->width))].r = 255;


		}
	}
}




void Draw_Box(JPEG_INFO_STRUCT *jpeg_data,int x,int y,int sx,int sy)
{
int nx,ny;
PIXEL_STRUCT *pixel;
pixel=jpeg_data->image;
for (nx=0; nx<=sx ; nx++) {

		pixel[((x-(sx/2))+nx)+((y+(sy/2)))].r = 
		pixel[((x-(sx/2))+nx)+((y+(sy/2)))].g = 
		pixel[((x-(sx/2))+nx)+((y+(sy/2)))].b = 0;
}
for (nx=0; nx<=sx ; nx++) {

		pixel[((x-(sx/2))+nx)+((y-(sy/2)))].r = 
		pixel[((x-(sx/2))+nx)+((y-(sy/2)))].g = 
		pixel[((x-(sx/2))+nx)+((y-(sy/2)))].b = 0;
}


for (ny=0; ny<=sy ; ny++) {

		pixel[(((x-(sx/2)))+((y+(sy/2))-ny)*(jpeg_data->width))].r = 
		pixel[(((x-(sx/2)))+((y+(sy/2))-ny)*(jpeg_data->width))].g = 
		pixel[(((x-(sx/2)))+((y+(sy/2))-ny)*(jpeg_data->width))].b = 0;
}

for (ny=0; ny<=sy ; ny++) {

		pixel[(((x+(sx/2)))+((y+(sy/2))-ny)*(jpeg_data->width))].r = 
		pixel[(((x+(sx/2)))+((y+(sy/2))-ny)*(jpeg_data->width))].g = 
		pixel[(((x+(sx/2)))+((y+(sy/2))-ny)*(jpeg_data->width))].b = 0;
}

}


void Image_ColorRemove(JPEG_INFO_STRUCT *jpeg_data, int x, int y, int colTol)
{
	PIXEL_STRUCT *pixel;

	int nx,ny;
	int colorAvrR=0,colorAvrG=0,colorAvrB=0,count=0;

	//size of box to average
	int sbx = 3,
		sby = 3;

	pixel = jpeg_data->image;

	for(ny=(y-((sby-1)/2)); ny<=(y+((sby-1)/2)); ny++){
		for(nx=(x-((sbx-1)/2)); nx<=(x+((sbx-1)/2)); nx++){



			colorAvrR += pixel[(nx)+(ny*(jpeg_data->width))].r;
			colorAvrG += pixel[(nx)+(ny*(jpeg_data->width))].g; 
			colorAvrB += pixel[(nx)+(ny*(jpeg_data->width))].b;
			count++;
		}
	}
//average of each color part...
	colorAvrR = (colorAvrR/count);
	colorAvrG = (colorAvrG/count);
	colorAvrB = (colorAvrB/count);

	for(ny=0; ny<=((jpeg_data->height)-1); ny++){
		for(nx=0; nx<=((jpeg_data->width)-1); nx++){


						printf("[-,%d]\n",ny);

			if (((pixel[(nx)+(ny*(jpeg_data->width))].r) < (colorAvrR-colTol))
				||((pixel[(nx)+(ny*(jpeg_data->width))].r) > (colorAvrR+colTol)))

			pixel[(nx)+(ny*(jpeg_data->width))].r = 255;


			if (((pixel[(nx)+(ny*(jpeg_data->width))].g) < (colorAvrG-colTol))
				||((pixel[(nx)+(ny*(jpeg_data->width))].g) > (colorAvrG+colTol)))

			pixel[(nx)+(ny*(jpeg_data->width))].g = 255;


			if (((pixel[(nx)+(ny*(jpeg_data->width))].b) < (colorAvrB-colTol))
				||((pixel[(nx)+(ny*(jpeg_data->width))].b) > (colorAvrB+colTol)))

			pixel[(nx)+(ny*(jpeg_data->width))].b = 255;


		}
	}


}


void Image_ScanBox(JPEG_INFO_STRUCT *jpeg_data,
		int x, int y, int sx, int sy, int sbx, 
		int sby, int trackTot)
{
	PIXEL_STRUCT *pixel;
	int nx,ny,currentTot,storeTot;//storeX,storeY,count;
	int sbBoxX=(x-(sbx/2)) , sbBoxY=(y-(sby/2));
	//count = 1;
	pixel = jpeg_data->image;
	
	storeTot = 0;

	for(ny=0; ny<=sby; ny++){
		for(nx=0; nx<=sbx; nx++){
			  
			  currentTot = blockTotal(jpeg_data, nx+(sbBoxX), ny+sbBoxY, sx, sy);
			  //cout << ".";
			  if (trackTot < currentTot) 
				  currentTot = ((trackTot*2)-currentTot);
						
		
			  if ((storeTot <= currentTot)&&(currentTot <= trackTot )){



				  matchPoint.x=nx+(sbBoxX);
				  matchPoint.y=ny+(sbBoxY);
				  storeTot=currentTot;
			  }
		}
	}

}




/*-------------------------------------------------------------*/
/*-------------------------------------------------------------*/

int main()
{
	JPEG_INFO_STRUCT *jpeg_data;
	JPEG_INFO_STRUCT *last_data;
	JPEG_INFO_STRUCT *show_data;
	trackPoint inner_box;

	int stopProg,nof,isx,isy,trackTot=0;
	char fileName[128];
	//initialise the center of the inner box
	inner_box.x = 0;
	inner_box.y = 0;
	last_data = NULL;
	nof = 2;
	matchPoint.x=270;
	matchPoint.y=156;




	for (int i=1; i<=nof; i++){





//load files...
		// on first time round
		if (i==1){

			printf("in loop 1\n");
			sprintf(fileName, "G:\\Motest\\walldot_%d.jpg", i);
			jpeg_data = EasyJPEG_Load(fileName);
			if(jpeg_data == NULL)
				{
					printf("Unable to load JPEG.\n");
					return(0);
				}
			show_data = jpeg_data;


			Image_ColorRemove(jpeg_data, matchPoint.x, matchPoint.y, 30);
			Image_ColorBlock(show_data,matchPoint.x,matchPoint.y);

	
// save file.
			sprintf(fileName, "G:\\Motest\\track_%d.jpg", i-1);
			if(!EasyJPEG_Save(show_data,fileName ,90))
				{
				printf("Unable to save JPEG image.\n");
				}

		
		}
		else{


			last_data = jpeg_data;
				
			sprintf(fileName, "G:\\Motest\\walldot_%d.jpg", i);
			jpeg_data = EasyJPEG_Load(fileName);
			if(jpeg_data == NULL)
			{
				printf("Unable to load JPEG.\n");
				return(0);
			}

			show_data = jpeg_data;


			inner_box.x = matchPoint.x;
			inner_box.y = matchPoint.y;
			isx = 8;
			isy = 8;

			printf("[%d]",i);

			trackTot=blockTotal(last_data, inner_box.x, inner_box.y, isx, isy);


			Image_ColorRemove(jpeg_data, inner_box.x, inner_box.y, 30);
			Image_ScanBox( jpeg_data,
				inner_box.x, inner_box.y, isx, isy, 25, 25,trackTot);

			//Draw_Box(jpeg_data,matchPoint.x,matchPoint.y,20,20);

    		//cout << "\n-[" << matchPoint.x << "," << matchPoint.y << "]";
			Image_ColorBlock(show_data,matchPoint.x,matchPoint.y);




	
// save file.
			sprintf(fileName, "G:\\Motest\\track_%d.jpg", i);
			if(!EasyJPEG_Save(show_data,fileName ,90))
				{
					printf("Unable to save JPEG image.\n");
				}
			
		}






	}

		EasyJPEG_Free(jpeg_data);
		EasyJPEG_Free(last_data);
		EasyJPEG_Free(show_data);
		cout << "finished" << "\n";
		cin >> stopProg;

	return(1);
	

}

/*--------------------------------------------------------------*/
/*--------------------------------------------------------------*/
