extern "C" {

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

}
#include <math.h>

#define PI() 3.1415

typedef struct coord {
	int x;
	int y;
} COORD;


typedef struct coord3d {
	double x,y,z;

} COORD3D;


void main()
 {

  char progArgs[128];
  int initXcoord = 436, initYcoord = 359, totalFrms = 35, i;
  double screenD = 1.0;  
  int imageResx=720,imageResy=576;

  double scale=1,
         hAperture=1.42,
	 wAperture=0.945;


  COORD currentPosition, iP;
  COORD3D A,rot,tdpos;
  FILE *coordFile,*outFile;

  // -------------------------------------
  // Send args to tracker
  // -------------------------------------

  sprintf(progArgs, "track %d %d %d", initXcoord, initYcoord, totalFrms);
//  system(progArgs);


  // -------------------------------------
  // Read output file
  // -------------------------------------
  coordFile = fopen("ocoords.dat", "r");
  assert(coordFile);

  for(i=1; i<=totalFrms; i++){
        fread(&currentPosition,sizeof(currentPosition),1,coordFile);
 
         tdpos.x=((double)currentPosition.x/(double)imageResx)*scale*hAperture;
         tdpos.y=((double)currentPosition.y/(double)imageResy)*scale*wAperture;
         tdpos.z=0.0;
        if(i==1) {
 		iP.x = tdpos.x;
		iP.y = tdpos.y;
                A.x = 0.0;
                A.y = 0.0;
                A.z = screenD;

                 rot.x = atan(A.x/A.z);
                 rot.y = atan(A.y/A.z);

                outFile=fopen("3dcoords.dat", "w");
                 fwrite(&rot.x,sizeof(rot.x),1,outFile);
                 fwrite(&rot.y,sizeof(rot.y),1,outFile);
                fclose(outFile);        
         }

        if(i>1) {
                A.x = (((double)iP.x - (double)tdpos.x));
                A.y = (((double)tdpos.y - (double)iP.y));               
                A.z = screenD;

// convert to rotation from radians to degrees

                 rot.x = (atan(A.x/A.z)* (360/(2*PI())));
                 rot.y = (atan(A.y/A.z)* (360/(2*PI())));



                outFile=fopen("3dcoords.dat", "a");
                 fwrite(&rot.x,sizeof(rot.x),1,outFile);
                 fwrite(&rot.y,sizeof(rot.y),1,outFile);
                fclose(outFile);   
		}


      printf("%f, %f, %f - \n", A.x, A.y, A.z);           
      printf("(%f,%f)\n", rot.x, rot.y);
  }
  fclose(coordFile);


 }
