//**********************************************************
//**********************************************************
//----Pattern tracking system - Innovations project
//----Steve Dawson u9700985
//
//Usage:
//
//trackPoint fileName.#.ext x y n output.dat
//
//
//Where:
//
//fileName.#.ext- name of file sequence with # in place of the number.
//x		- x coordinate of point to be tracked.
//y		- y coordinate of point to be tracked.
//n		- number of frames to be converted
//output.dat	- name of the data file to out
//
//**********************************************************
//**********************************************************

#define SBOXTHICKNESS 12
#define BBOXTHICKNESS 20

extern "C" {

#include <stdio.h>
#include <stdlib.h>
#include "tiffStuff/pixmap/NCCAPixmap.h"
#include <string.h>
}


NCCAPixmap initPattern;

typedef struct coord {
	int x;
	int y;
} COORD;


#include "scoreSys.h"
#include "searchMatch.h"
#include "showPoint.h"

/*
char file[128], *pos;

 FileNameEnd = strrchr(file,'#');
 FileNameEnd[0] = '\0';
 FileNameEnd++;
 sprintf(filename,"%s%04d%s",file,n,FileNameEnd);


*/


void main(int argc, char *argv[])
{

  printf("\n\n\n\n\n\n\n");
  FILE *coordFile;

//----------------------------------------  
//Separating File name from extention at #
//----------------------------------------

  char inputImageFile[128], *fileNameEnd;
  strcpy (inputImageFile,argv[1]);


    fileNameEnd = strrchr(inputImageFile,'#');
    fileNameEnd[0] = '\0';
    fileNameEnd++;

//----------------------------------------

  int xcoord = atoi(argv[2]);
  int ycoord = atoi(argv[3]);
  int frameno = atoi(argv[4]);

  char outputFileName[128];
  strcpy (outputFileName,argv[5]);


  NCCAPixmap srcInFile, currentInFile, destFile;//Pixmap to store source and
						//current images
  int frames = frameno, currFrame=0;
  COORD finalPosition,currentPosition;

  char srcfileName[128],	   //Filenames
       currentfileName[128],
       destfileName[128];

  currentPosition.x = xcoord;
  currentPosition.y = ycoord;

// -------------------------------------
// Open file to store coords in...
// -------------------------------------
  coordFile = fopen("ocoords.dat", "w");
  fwrite(&currentPosition,sizeof(currentPosition),1,coordFile);
  fclose(coordFile);



// Store basic element...

  sprintf(srcfileName, "%s1%s", inputImageFile, fileNameEnd);
  printf("\nLoading first...%s\n", srcfileName);
  srcInFile = loadPixmap(srcfileName);        //Load source
  initPattern = copybox(srcInFile, currentPosition.x, currentPosition.y);



  printf("\n\nThe start position is (%d,%d) \n\n\n", currentPosition.x, currentPosition.y);

  for (currFrame=1; currFrame < frames; currFrame++) {


    sprintf(currentfileName, "%s%d%s", inputImageFile,(currFrame+1), fileNameEnd);
    sprintf(destfileName, "./configTest.dir/output%d.tif", (currFrame+1));


    printf("\nLoading...%s\n", currentfileName);
    currentInFile = loadPixmap(currentfileName);  //images



    printf("\n\nThe current position is (%d,%d) \n\n\n", currentPosition.x, currentPosition.y);

    //Search...

    finalPosition = searchTrackBox(initPattern, currentInFile, currentPosition.x, currentPosition.y);
    printf("\n\nThe new position is (%d,%d) \n\n\n", finalPosition.x, finalPosition.y);


    destFile = drawBox(currentInFile, finalPosition.x, finalPosition.y, SBOXTHICKNESS);


    printf("\nSaving...%s\n", destfileName);
    savePixmap(destFile, destfileName);
    
    currentPosition = finalPosition;  //set new goal...


    // -------------------------------------
    // Open file to store coords in...
    // -------------------------------------
    coordFile = fopen(outputFileName, "a");
    fwrite(&currentPosition,sizeof(currentPosition),1,coordFile);
    fclose(coordFile);




  }

  destroyPixmap(currentInFile);
  destroyPixmap(srcInFile);
  destroyPixmap(destFile);
};
